Currently the CLI Command resolving is mostly handled by the CLI Request Builder.
But it still has some glitches (see https://review.typo3.org/#change,3298).
Besides there is some duplicated code, as we need to find available commands in various places.

My suggestion is to add a central service that knows all commands (and in which controller they reside) and can also match an input
to existing commands.

The API could be:

class CommandManager {

    /**
     * @return array<Command>
     */
    public function getAvailableCommands();

    /**
     * @string $commandIdentifier foo.bar:baz:foos
     * @return Command
     * @throws CommandNotFoundException if no matching command is available
     * @throws AmbiguousCommandIdentifierException if more than one Command matches the identifier (the exception
contains the matched commands)
     */
    public function getCommandByIdentifier($commandIdentifier);

}

Related issues:
related to TYPO3.Flow - Bug # 28294: Command is not run in compile time if co... Resolved 2011-07-18

Associated revisions
Revision 9d27dabc - 2011-07-19 20:22 - Bastian Waidelich

[FEATURE] CLI CommandManager

This change adds a CommandManager that should be used as central
service whenever dealing with CLI commands.
Besides the HelpCommand is cleaned slightly and makes use of the
CommandManager internally to avoid code duplication.
This is a refactoring, that doesn't introduce new behaviour.

Change-Id: I1f443869a6b93b551e8ffd5bc3957a6935310869
Resolves: #28172

History
#1 - 2011-07-13 12:52 - Bastian Waidelich
- Subject changed from Provide CommandService to Provide CommandManager

#2 - 2011-07-13 17:53 - Mr. Hudson
- Status changed from New to Under Review

Patch set 1 of change I1f443869a6b93b551e8ffd5bc3957a6935310869 has been pushed to the review server.
It is available at http://review.typo3.org/3311

#3 - 2011-07-19 18:37 - Mr. Hudson

Patch set 2 of change I1f443869a6b93b551e8ffd5bc3957a6935310869 has been pushed to the review server.
It is available at http://review.typo3.org/3311

#4 - 2011-07-19 20:22 - Mr. Hudson

Patch set 3 of change I1f443869a6b93b551e8ffd5bc3957a6935310869 has been pushed to the review server.
It is available at http://review.typo3.org/3311

#5 - 2011-07-20 09:05 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:9d27dabc0bf43d6d1c68d88cdf1f827600ca5119.
